' SetACL script
' Part of PDFCreator
' License: GPL
' Homepage: http://bent-blog.de
' Version: 1.5
' Date: March, 03. 2014
' Author: Bent Schrader

Option Explicit

On Error Resume Next

Const AppTitle = "PDFCreator - SetACL"
Const ICACLS = "\System32\icacls.exe"
Const EVENTCREATE = "\System32\eventcreate.exe"
Const Version = "1.5"
Const Debug = 0

Dim objArgs, OutputFile, User, objFSO, objEnv, WshShell, wshNetwork, objFile, Message, strMessage, strOutputFile, strCommand
Set wshNetwork = WScript.CreateObject( "WScript.Network" )
Set WshShell = CreateObject("WScript.Shell")
Set objFSO = CreateObject("Scripting.FileSystemObject")
Set objEnv = WshShell.Environment("Process")

Set objArgs = WScript.Arguments

Err.Clear()

Function ErrorMessage(strMessage)
	WshShell.Run objEnv("SYSTEMROOT") & EVENTCREATE & " /L Application  /T ERROR /SO " & Chr(34) & objArgs(2) & Chr(34) &_
	" /ID 111 /D " & Chr(34) & "PDF-Drucker-Skript (" & WScript.ScriptFullName & ") v" & Version & " auf " & WshNetwork.ComputerName &_
	" hat einen Fehler verursacht:" & vbCrLf & vbCrLf & "Drucker:" & vbTab & vbTab & objArgs(2) & vbCrLf & "Benutzer:" & vbTab &_
	wshNetwork.UserDomain & "\" & User & vbCrLf & vbCrLf & strMessage & Chr(34),0,True
	WScript.Quit
End Function

Function InfoMessage(strMessage)
	WshShell.Run objEnv("SYSTEMROOT") & EVENTCREATE & " /L Application  /T Information /SO " & Chr(34) & objArgs(2) & Chr(34) &_
	" /ID 111 /D " & Chr(34) & "PDF-Drucker-Skript (" & WScript.ScriptFullName & ") v" & Version & " auf " & WshNetwork.ComputerName &_
	vbCrLf & vbCrLf & "Drucker:" & vbTab & vbTab & objArgs(2) & vbCrLf & "Benutzer:" & vbTab & wshNetwork.UserDomain & "\" & User & vbCrLf &_
	vbCrLf & strMessage & Chr(34),0,True
End Function

'Check the correct amount of arguments
If objArgs.Count < 3 Then
	ErrorMessage("Falsche Anzahl an Parametern, bentigt werden: <OutputFile> <Author> <PrinterName>.")
End If

OutputFile = objArgs(0) 
User = objArgs(1)

If Debug <> 0 Then
	InfoMessage("OutputFile: " & OutputFile & vbCrLf & "Autor: " & User & vbCrLf)
End If

'Sonderzeichenbehandlung
OutputFile = Replace(OutputFile, "/", "_")
OutputFile = Replace(OutputFile, "|", "_")
OutputFile = Replace(OutputFile, " ", "_")

strOutputFile = "Dokument:" & vbTab & Chr(34) & OutputFile & Chr(34) & vbCrLf

If Debug <> 0 Then
	InfoMessage("OutputFile (bereinigt): " & OutputFile)
End If

'Check whether the given file exists
If objFSO.FileExists(OutputFile) Then
	Set objFile = objFSO.GetFile(OutputFile)
Else
	ErrorMessage("Die in <OutputFile> bergebene Datei [" & OutputFile & "] existiert nicht.")
End If

' Set permissions and ownership
If objFSO.FileExists(OutputFile) Then
	strCommand = objEnv("SYSTEMROOT") & ICACLS & " " & Chr(34) & OutputFile & Chr(34) & " /grant " & wshNetwork.UserDomain & "\" & User & ":F /Q"
	If Debug <> 0 Then
		InfoMessage("Execute: " & strCommand)
	End If
	Message = WshShell.Run (strCommand,0,True)
	strCommand = objEnv("SYSTEMROOT") & ICACLS & " " & Chr(34) & OutputFile & Chr(34) & " /setowner " & wshNetwork.UserDomain & "\" & User & " /Q"
	If Debug <> 0 Then
		InfoMessage("Execute: " & strCommand)
	End If
	Message = WshShell.Run (strCommand,0,True)
End If

'Log to application event log
If Err.Number <> 0 OR Message Then
	ErrorMessage(strOutputFile & "Fehlernummer: " & Err.Number & ", Quelle: " & Err.Source & ", Details: " & Err.Description & " " & Message)
End If

InfoMessage(strOutputFile & vbCrLf & "Dateigre:" & vbTab & FormatNumber((objFile.Size / 1024),1) & " KBytes")